/*
 * This file is part of Pustefix.
 *
 * Pustefix is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Pustefix is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Pustefix; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
    
package sample.games.hangman.wrapper;
    
import de.schlund.pfixcore.generator.*;

import de.schlund.pfixcore.generator.annotation.*;

/**
 * THIS CLASS IS AUTOGENERATED! DO NOT EDIT IN ANY WAY!
 */
@UseHandlerClass(sample.games.hangman.handler.SettingsHandler.class)
public class Settings extends IWrapperImpl {

    @Override
    protected synchronized void registerParams() {
        
        IWrapperParam          pinfo;
        
        IWrapperParamCaster    caster;
         
        IWrapperParamPreCheck  pre;
        
        // Level
        if(!params.containsKey("Level")) {
        pinfo  = new IWrapperParam("Level", false, false, null, "java.lang.String", true);
          
        params.put("Level", pinfo);
          
        pre = new de.schlund.pfixcore.generator.prechecks.RegexpCheck();
        pinfo.addPreChecker(pre);
    
        ((de.schlund.pfixcore.generator.prechecks.RegexpCheck) pre).setRegexp("/^(BEGINNER|ADVANCED|EXPERT)$/");
    
        }  
        
      
        // Language
        if(!params.containsKey("Language")) {
        pinfo  = new IWrapperParam("Language", false, false, null, "java.lang.String", true);
          
        params.put("Language", pinfo);
          
        pre = new de.schlund.pfixcore.generator.prechecks.RegexpCheck();
        pinfo.addPreChecker(pre);
    
        ((de.schlund.pfixcore.generator.prechecks.RegexpCheck) pre).setRegexp("/^(en|de)$/");
    
        }  
        
      
        // Memory
        if(!params.containsKey("Memory")) {
        pinfo  = new IWrapperParam("Memory", false, false, new de.schlund.pfixxml.RequestParam[] {new de.schlund.pfixxml.SimpleRequestParam("false")}, "java.lang.Boolean", true);
          
        params.put("Memory", pinfo);
          
        caster = new de.schlund.pfixcore.generator.casters.ToBoolean();
        pinfo.setParamCaster(caster);
    
        }  
        
      
        super.registerParams();
    }
    
    // Level
    @PreCheck(
        type=de.schlund.pfixcore.generator.prechecks.RegexpCheck.class,
        properties={
            @Property(name="regexp",value="/^(BEGINNER|ADVANCED|EXPERT)$/")
        }
    )
    public java.lang.String getLevel() {
        return (java.lang.String) gimmeParamForKey("Level").getValue();
    }
    
    public void setStringValLevel(String v) {
        gimmeParamForKey("Level").
          setStringValue(new String[] {v});
    }

    public void setLevel(java.lang.String v) {
        IWrapperParam iwrpParam = gimmeParamForKey("Level");
        setStringValue(new java.lang.String[] {v}, iwrpParam);
    }

    public void addSCodeLevel(de.schlund.util.statuscodes.StatusCode scode) {
        addSCode(gimmeParamForKey("Level"), scode, null, null);
    }

    public void addSCodeLevel(de.schlund.util.statuscodes.StatusCode scode, String[] args, String level) {
        addSCode(gimmeParamForKey("Level"), scode, args, level);
    }

    /**
      * @deprecated use addScodeLevel(scode, args, null)
      */
    @Deprecated
    public void addSCodeWithArgsLevel(de.schlund.util.statuscodes.StatusCode scode, String[] args) {
        addSCode(gimmeParamForKey("Level"), scode, args, null);
    }
        
    // Language
    @PreCheck(
        type=de.schlund.pfixcore.generator.prechecks.RegexpCheck.class,
        properties={
            @Property(name="regexp",value="/^(en|de)$/")
        }
    )
    public java.lang.String getLanguage() {
        return (java.lang.String) gimmeParamForKey("Language").getValue();
    }
    
    public void setStringValLanguage(String v) {
        gimmeParamForKey("Language").
          setStringValue(new String[] {v});
    }

    public void setLanguage(java.lang.String v) {
        IWrapperParam iwrpParam = gimmeParamForKey("Language");
        setStringValue(new java.lang.String[] {v}, iwrpParam);
    }

    public void addSCodeLanguage(de.schlund.util.statuscodes.StatusCode scode) {
        addSCode(gimmeParamForKey("Language"), scode, null, null);
    }

    public void addSCodeLanguage(de.schlund.util.statuscodes.StatusCode scode, String[] args, String level) {
        addSCode(gimmeParamForKey("Language"), scode, args, level);
    }

    /**
      * @deprecated use addScodeLanguage(scode, args, null)
      */
    @Deprecated
    public void addSCodeWithArgsLanguage(de.schlund.util.statuscodes.StatusCode scode, String[] args) {
        addSCode(gimmeParamForKey("Language"), scode, args, null);
    }
        
    // Memory
    @Caster(
        type=de.schlund.pfixcore.generator.casters.ToBoolean.class
    )
    public java.lang.Boolean getMemory() {
        return (java.lang.Boolean) gimmeParamForKey("Memory").getValue();
    }
    
    public void setStringValMemory(String v) {
        gimmeParamForKey("Memory").
          setStringValue(new String[] {v});
    }

    public void setMemory(java.lang.Boolean v) {
        IWrapperParam iwrpParam = gimmeParamForKey("Memory");
        setStringValue(new java.lang.Boolean[] {v}, iwrpParam);
    }

    public void addSCodeMemory(de.schlund.util.statuscodes.StatusCode scode) {
        addSCode(gimmeParamForKey("Memory"), scode, null, null);
    }

    public void addSCodeMemory(de.schlund.util.statuscodes.StatusCode scode, String[] args, String level) {
        addSCode(gimmeParamForKey("Memory"), scode, args, level);
    }

    /**
      * @deprecated use addScodeMemory(scode, args, null)
      */
    @Deprecated
    public void addSCodeWithArgsMemory(de.schlund.util.statuscodes.StatusCode scode, String[] args) {
        addSCode(gimmeParamForKey("Memory"), scode, args, null);
    }
        
}
  